Category: Map Composer/Printing

Pull Request or Patch supplied: Resolution: fixed/implemented
Easy fix?: No Copied to github as #: 17472
Description

Good morning to the QGIS community,

First off, thank you for QGIS 2.0.1, its a great piece of software and the GUI is fantastic. | have been looking forward to the atlas
integration for a long time but | don't think it's quite there yet. When | print map books, | often have features close together. What | would
like Atlas to do is apply a filter so that only the current feature is visible (or all features expect the current is visible). What | envisage is a
feature similar to ESRIs data driven pages, page definition queries (http://tinyurl.com/p5ptg28).

| posted this request in the User Forum (http:/tinyurl.com/puvazlh) but Vincent Picavet suggested | post it here. I'm not sure if this is

already possible. | have tried several iteration in the feature filter dialog such as $feature=$feature or $rownum=$rownum with no

success. The expression $feature=$currentfeature (if there was a $currentfeature) might work. On a layer by layer basis, a tick box in the

layer filter option called "atlas filtering" might also be an option.

Thanks,

David

Associated revisions

Revision bff6fe59 - 2013-11-07 12:09 PM - Nathan Woodrow

Set currentfeature expression variable for Atlas printing. Fix #8766

History

#1 - 2013-10-04 04:30 AM - Giovanni Manghi
- Target version set to Future Release - Nice to have
- Category set to Map Composer/Printing

#2 - 2013-11-07 03:11 AM - Anonymous
- Status changed from Open to Closed

Fixed in changeset commit:"bff6fe5913f2666b5d90cead 7ae062b429604a22".

#3 - 2013-11-07 03:14 AM - Nathan Woodrow
- File output_1.jpg added
- Resolution set to fixed/implemented

Now that we have $currentfeature we can match that in a rule to highlight the active Atlas feature.
http://tinyurl.com/p5ptq28
http://tinyurl.com/puvazlh

http://i.imgur.com/2SHORtC.png

Result:

http://i.imgur.com/7pFklzL.jpg

#4 - 2013-11-07 05:36 AM - Regis Haubourg

Hi, | was about to ask the same feature! So great.. The idea was to be able to filter labeling only in currentfeature with a intersect clause.
Having another feature simplified on the current scale (with new simplification improvement by A.Huarte and V.Mora) would avoid performances issues
with big polygons.. My two cents.

Régis

#5 - 2013-11-07 03:01 PM - Nathan Woodrow

Regis,

You could do this in using a CASE in a label expression (for now)

CASE

WHEN $id = $currentfeature THEN "yourlabel"

END

http://i.imgur.com/xEzgcF0.png

You could even use a case statement in the transparency property to get something like this.

CASE

WHEN $id != $currentfeature THEN 50

END

http://i.imgur.com/uaPbZMy.png

#6 - 2013-11-07 04:26 PM - Mathieu Pellerin - nIRV

kudos Nathan, that's very useful

#7 - 2013-11-08 12:45 AM - Regis Haubourg

Nathan Woodrow wrote:

Regis,

You could do this in using a CASE in a label expression (for now)

CASE

WHEN $id = $currentfeature THEN "yourlabel”
END
Hi Nathan,
that works only for Atlas coverage layer right ?

#8 - 2013-11-11 03:49 AM - David McDermott

Thank you Nathan, this is perfect. How do | go about implementing this fix? | downloaded and installed the most recent (10/11/13) version of QGIS but

there is no $Currentfeature function.

#9 - 2013-11-11 03:56 AM - Nathan Woodrow

Have you enabled Atlas in the composer. It will only be active then.

#10 - 2013-11-11 04:20 AM - David McDermott
- File atlas_on.png added
- File atlas_exp.png added

Atlas composer is active, and | have the $feature function. | took your idea and put ($feature + 1) = $id in the style expression and it works. | have added a

few photos.

#11 - 2013-11-11 04:24 AM - Nathan Woodrow

I wouldn't use $feature + 1 because $feature is just a count and $id is not ordered or can having missing numbers so this expression will fail.

Can you QGIS Code revision you have in your About dialog.

#12 - 2013-11-11 05:30 AM - David McDermott
- File qgis_version.png added

My $feature+1 $id was just a temporary workaround that worked on this dataset. The code version is ebebdf3. Here is a screen shot

#13 - 2013-11-11 05:38 AM - Nathan Woodrow

Oh your still running 2.0. You will have to grab a nightly build if you want this feature. You can get the nighly dev version using the OSGeo4W installers at

http://qgis.org/en/site/forusers/download.html

#14 - 2013-11-18 05:22 AM - Regis Haubourg

Hi Nathan,
| can't see $currentfeature variable in latest revision on OSGEO4W (5f5cd4c) , with Atlas enabled..
Any idea? OSGEO4W is late?

#15 - 2013-11-18 05:28 AM - Nathan Woodrow
Very old. Are you using the OSGeo4W of the qgis site?

#16 - 2013-11-18 05:41 AM - Regis Haubourg

Yep, updated osgeodw 64 bit today. Will check 32 bit now...

#17 - 2013-11-18 05:43 AM - Regis Haubourg

Hum, in fact 32 bit package is realy old, 64 bit is up to 2.1.0-60

#18 - 2013-11-18 07:04 AM - Jiirgen Fischer

regis Haubourg wrote:

Hum, in fact 32 bit package is realy old, 64 bit is up to 2.1.0-60

What do you mean? The packages both are from today.

#19 - 2013-11-18 07:36 AM - Regis Haubourg

In my 32 bit osgeo4w installer, | get 2.1.0-55 where | get -60 in 64 bits version.

#20 - 2013-11-18 08:01 AM - Jiirgen Fischer

regis Haubourg wrote:

In my 32 bit osgeo4w installer, | get 2.1.0-55 where | get -60 in 64 bits version.

Right, but that doesn't mean they contain different QGIS versions. Just that the 32bit version wasn't built successfully as many many times as the 64bit

version.

#21 - 2013-11-18 08:29 AM - Regis Haubourg

Ok, didn't know that. Anyway, it seems nathan's code is not functionnal in 32 bit package. Maybe other reasons explain that.

#22 - 2013-11-18 12:58 PM - Nathan Woodrow

Can you paste a image of your about QGIS dialog.

#23 - 2013-11-19 12:56 AM - Regis Haubourg

here is what | see:
Version de QGIS 2.0.1-Dufour Révision du code ebebdf3
Compilé avec Qt 4.7.1 UtilisantQt 4.7.1
Compilé avec GDAL/OGR 1.10.1 Utilisé avec GDAL/OGR 1.10.1

Compiled against GEOS 3.3.8-CAPI-1.7.8 Running against GEOS 3.4.2-CAPI-1.8.2r3921

Version du client PostgreSQL  8.3.10 Version de SpatiaLite 4.1.1
Versionde QWT 5.2.1 Versionde PROJ.4: 480
Version de QScintilla2 2.6.2

Files

output_1.jpg 186 KB 2013-11-07 Nathan Woodrow
atlas_exp.png 27 KB 2013-11-11 David McDermott
atlas_on.png 19.4 KB 2013-11-11 David McDermott
qgis_version.png 35.8 KB 2013-11-11 David McDermott
